version: '3.7'

services:
  nextcloud:
    image: ${IMAGE_NAME:-registry.gitlab.com/vente1/cloud/nextcloud}:${IMAGE_TAG:-latest}
    environment:
      - POSTGRES_DB
      - POSTGRES_PASSWORD
      - POSTGRES_USER
      - POSTGRES_HOST
      - SMTP_HOST
      - SMTP_SECURE
      - SMTP_PORT
      - SMTP_AUTHTYPE
      - SMTP_NAME
      - SMTP_PASSWORD
      - MAIL_FROM_ADDRESS
      - MAIL_DOMAIN
      - OVERWRITEPROTOCOL
    networks:
      cloud-net:
      traefik-net:
    volumes:
      - nextcloud-main-vol:/var/www/html
      - nextcloud-apps-vol:/var/www/html/custom_apps
      - nextcloud-config-vol:/var/www/html/config
      - nextcloud-data-vol:/var/www/html/data
      - nextcloud-theme-vol:/var/www/html/themes/vente
    deploy:
      labels:
        traefik.http.routers.nextcloud.entrypoints: https
        traefik.http.routers.nextcloud.rule: Host(`${SITE_SUBDOMAIN:-nextcloud}.${PUBLIC_HOSTNAME}`)
        traefik.http.services.nextcloud.loadbalancer.server.port: '${NEXTCLOUD_PORT:-80}'
        traefik.http.routers.nextcloud.tls.certresolver: default
        traefik.http.middlewares.nextcloud-redirectregex.redirectregex.regex: "^https://(.*)/.well-known/(card|cal)dav"
        traefik.http.middlewares.nextcloud-redirectregex.redirectregex.replacement: "https://$${1}/remote.php/dav/"
        traefik.http.middlewares.nextcloud-redirectregex.redirectregex.permanent: 'true'
        traefik.http.middlewares.nextcloud-headers.headers.customresponseheaders.Strict-Transport-Security: max-age=63072000; includeSubDomains; preload
        traefik.http.middlewares.nextcloud-compress.compress: 'true'
        traefik.http.routers.nextcloud.middlewares: nextcloud-redirectregex, nextcloud-headers, nextcloud-compress


networks:
  cloud-net:
    name: ${CLOUD_NET_NAME:-cloud-net}
    driver: overlay
    attachable: true
  traefik-net:
    name: ${TRAEFIK_NET_NAME:-traefik-net}
    external: true

volumes:
  nextcloud-main-vol:
    name: ${NEXTCLOUD_MAIN_VOLUME_NAME:-nextcloud-main-vol}
  nextcloud-apps-vol:
    name: ${NEXTCLOUD_APPS_VOLUME_NAME:-nextcloud-apps-vol}
  nextcloud-config-vol:
    name: ${NEXTCLOUD_CONFIG_VOLUME_NAME:-nextcloud-config-vol}
  nextcloud-data-vol:
    name: ${NEXTCLOUD_DATA_VOLUME_NAME:-nextcloud-data-vol}
  nextcloud-theme-vol:
    name: ${NEXTCLOUD_THEME_VOLUME_NAME:-nextcloud-theme-vol}
